//+------------------------------------------------------------------+
//|                                          AllPivots_v4.1 600+.mq4 |
//|                                Copyright  2015, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property description "Before using, please read the manual carefully http://newdigital-world.com/trading-tools/1649-allpivots-2.html#post4562"   
#property indicator_chart_window

#property strict

enum tf
{
   current   =      0,   //Current
   M1        =      1,   //M1
   M5        =      5,   //M5
   M15       =     15,   //M15
   M30       =     30,   //M30
   H1        =     60,   //H1
   H4        =    240,   //H4
   D1        =   1440,   //D1
   W1        =  10080,   //W1
   MN1       =  43200,   //MN1
   YR1       = 525600    //YR1
};

enum pvmode
{
   standard  =      0,   //Standard(BasePrice=Previous Typical)
   camarilla =      1,   //Camarilla(BasePrice=Previous Close)    
   demark    =      2,   //Demark's Pivots
   fibo_rel  =      3,   //Fibo relative and Avg Range Levels
   fibo_abs  =      4,   //Fibo absolute(in pips)
   woodie    =      5,   //Woodie's Pivots(BasePrice=Previous Weighted Open)
   dots      =      6    //DOTS Method Levels
};

enum rmode
{
   hilo_r    =      0,   //High/Low Range;
   updn_r    =      1,   //UpRange=High-BasePrice, DnRange=BasePrice-Low 
   close_r   =      2    //Range=Close-Close[1]
};

enum bprice
{
   close     =      0,   //Previous Close
   open      =      1,   //Current Open 
   high      =      2,   //Previous High   
   low       =      3,   //Previous Low   
   median    =      4,   //Previous Median    
   typical   =      5,   //Previous Typical  
   wclose    =      6,   //Previous Weighted Close      
   wopen     =      7    //Previous Weighted Open
};

enum dplace
{
   left      =      0,   //on the left      
   middle    =      1,   //in the center  
   right     =      2    //on the right   
};

//---- input parameters
extern string  set1              =  "";                  //==== Main settings: ====
extern tf      TimeFrame         =  D1;                  //TimeFrame 
extern string  UniqueName        =  "AllPivots";         //Unique Name
extern int     Length            =  5;                   //Length in periods(eg. 2= 2 days)  
extern pvmode  PivotMode         =  standard;            //Pivot Mode  
extern string  PivotValues       =  "0;1;2;3";           //Pivot values(ratios)
extern bprice  BasePrice         =  5;                   //Base Price
extern int     BaseHourShift     =  0;                   //Base Hour Shift(eg.0-start of the day)
extern int     ShowMedians       =  false;               //Show Medians 
extern rmode   RangeMode         =  0;                   //Range Mode
extern int     AvgPeriod         =  1;                   //Avg Period in bars  
extern int     SessionStartHour  =  0;                   //Session Start Hour(eg. 9 for DAX,0-for Forex)
extern int     SessionEndHour    =  0;                   //Session End Hour(eg. 22 for DAX,0-for Forex)
extern int     NumberOfDigits    =  4;                   //Number of digits after decimal point 

extern string  set2              =  "";                  //==== Visual settings: ====
extern bool    ShowGradientColor =  true;                //Show Gradient Colors
extern color   MainPivotColor    =  clrWhite;            //Main Pivot Color
extern int     MainPivotWidth    =  2;                   //Main Pivot Width
extern color   UpperLevelColor   =  clrYellowGreen;      //Upper Level Color         
extern color   LowerLevelColor   =  clrFireBrick;        //Lower Level Color
extern int     LineStyle         =  STYLE_SOLID;         //Line Style
extern int     LineWidth         =  1;                   //Line Width                   
extern int     MedianStyle       =  STYLE_DOT;           //Median Style
extern int     MedianWidth       =  0;                   //Median Width
extern bool    ShowPivotValues   =  false;               //Show Pivot Values(true/false)
extern string  FontName          =  "Arial";             //Font Name
extern int     FontSize          =  8;                   //Font Size
extern dplace  DescriptionPlace  =  left;                //Description Place
extern bool    ShowComment       =  false;               //Show Comments


//---- indicator buffers
double uprange[];
double dnrange[];
double pivotprice[];
double pivottime[];
double pivotshift[];
double high[];
double low[];
double open[];
double close[];
double prevopen[];


int      TF, shift, num,  pBars, size, upLineR, upLineG, upLineB, dnLineR, dnLineG, dnLineB, ppLineR, ppLineG, ppLineB, counter, digits;
bool     fTime;
datetime prevTime, last_timecurrent, time1, time2;
double   point, ratios[], P, R[], S[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   fTime = true;
   
   IndicatorBuffers(10);
   SetIndexBuffer(0,   uprange); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,   dnrange);
   SetIndexBuffer(2,pivotprice);
   SetIndexBuffer(3,pivotshift);
   SetIndexBuffer(4, pivottime);
   SetIndexBuffer(5,      high);
   SetIndexBuffer(6,       low);
   SetIndexBuffer(7,      open);
   SetIndexBuffer(8,     close);
   SetIndexBuffer(9,  prevopen);

   TF = TimeFrame;
   
   last_timecurrent = TimeCurrent();
   
   size = StrToDoubleArray(PivotValues,ratios,";"); 
   
   switch(PivotMode)
   {
   case 0:  size = 4; break;
   case 1:  size = 6; break;
   case 2:  size = 1; break;
   case 5:  size = 4; break;
   case 6:  size = 4; break;
   }
   
     
   ArrayResize(R,size);
   ArrayResize(S,size);
  
   
   colorToRGB(UpperLevelColor,upLineR,upLineG,upLineB);
   colorToRGB(LowerLevelColor,dnLineR,dnLineG,dnLineB);
   colorToRGB(MainPivotColor ,ppLineR,ppLineG,ppLineB);
   
   if(NumberOfDigits == 4) point = Point*MathPow(10,Digits%2); else point = Point;
   
   digits = countDigits(point);
      
return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+   
int deinit()
{
   ObjectDel(UniqueName);
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| AllPivots_v4.1 600+                                              |
//+------------------------------------------------------------------+
int start()
{
   int i, cnt, rnum, upColor1, upColor2, upColor3, dnColor1, dnColor2, dnColor3, counted_bars = IndicatorCounted();
   double x, coeff, mr, ms; 
   datetime tftime[], curTime, starthour, desctime;
   string ratio0, ratioR, ratioS, rname, sname;
   
   counter++;
   if(counter <  4) {TimeCurrent(); Comment("Please wait! ",4 - counter," ticks left"); return(0);}
   if(counter == 4) Comment(""); 
  
   if(TF == 525600) curTime = StrToTime((string)Year() + ".01.01"); else curTime = iTime(NULL,TF,0);

   
   if((curTime != prevTime && pBars > 0 && Bars > pBars) || fTime)  
   {
   ObjectDel(UniqueName);
   
      if(TF == 525600 || TF == 43200 || TF == 10080 || TF == 1440) 
      {
      i   = 0; 
      cnt = 0;
      
         while(i <= Bars-2 && cnt < Length+AvgPeriod) 
         {
         i++;   
            
            bool d1_condition = false;
            
            if(TimeDay(Time[i]) != TimeDay(Time[i+1]))
            {
               if(TimeDayOfWeek(Time[i]) < 2)
               {
                  if(TimeDayOfWeek(Time[i+1]) == 5) d1_condition = true;
               }
               else d1_condition = true;
            }
            
            if((TF == 525600 && TimeYear(Time[i])  != TimeYear(Time[i+1] ))||
               (TF == 43200  && TimeMonth(Time[i]) != TimeMonth(Time[i+1]))||
               (TF == 10080  && TimeDayOfWeek(Time[i]) < 2 && TimeDayOfWeek(Time[i+1]) == 5)||
               (TF == 1440   && d1_condition))
            {  
            cnt++;
            ArrayResize(tftime,cnt);
            tftime[cnt-1] = Time[i];
            }  
         }
      }
      
         
      for(shift=0;shift<Length+AvgPeriod;shift++)
      {
         if(TF >= 1440) 
         {
         starthour = tftime[shift] + SessionStartHour*3600;
         pivottime[shift] = (double)starthour + BaseHourShift*3600; 
         }
         else 
         {
         starthour = iTime(NULL,TF,shift) + SessionStartHour*3600;
         pivottime[shift] = (double)Time[iBarShift(NULL,0,starthour) - BaseHourShift*60/Period()]; 
         }
      
      pivotshift[shift] = iBarShift(NULL,0,(datetime)pivottime[shift],false);
      }
   
      for (shift=0;shift<Length+AvgPeriod;shift++)
      {
      int length = (int)(pivotshift[shift+1] - pivotshift[shift]);
            
      open[shift]  = iOpen(NULL,0,(int)pivotshift[shift]);
      high[shift]  = High[iHighest(NULL,0,MODE_HIGH,length,(int)pivotshift[shift]+1)];
      low[shift]   = Low [iLowest (NULL,0,MODE_LOW ,length,(int)pivotshift[shift]+1)];
      close[shift] = iClose(NULL,0,(int)pivotshift[shift]+1);   
      
      prevopen[shift] = iOpen(NULL,0,(int)pivotshift[shift]+length);
     
         if(PivotMode == 2)
         {
            if(close[shift] < prevopen[shift]) x = high[shift] + 2*low[shift] + close[shift];
            else
            if(close[shift] > prevopen[shift]) x = 2*high[shift] + low[shift] + close[shift];
            else x = high[shift] + low[shift] + 2*close[shift];
         
            pivotprice[shift] = x/4; 
         }
         else
         pivotprice[shift] = basePrice(BasePrice,prevopen[shift],open[shift],high[shift],low[shift],close[shift]);
      }
      
      for(shift=0;shift<Length+AvgPeriod;shift++)
      {
      
         switch(RangeMode)
         {
         case 0:  uprange[shift] = high[shift] - low[shift];
                  dnrange[shift] = uprange[shift]; 
                  break;
         
         case 1:  uprange[shift] = high[shift] - pivotprice[shift];
                  dnrange[shift] = pivotprice[shift] - low[shift]; 
                  break;
         
         case 2:  uprange[shift] = MathAbs(close[shift] - close[shift+1]);
                  dnrange[shift] = uprange[shift]; 
                  break;         
         }
      }
              
      for(shift=0;shift<Length;shift++)
      {
      double upR1 = 0, dnR1 = 0, upRavg = 0, dnRavg = 0;
      
      for(i=0;i<AvgPeriod;i++) 
      {
      upR1 += uprange[i+shift]; 
      dnR1 += dnrange[i+shift];
      }   
     
      upRavg  = upR1/AvgPeriod;  
      dnRavg  = dnR1/AvgPeriod;      
      
      time1   = (datetime)pivottime[shift];    
         
         if(shift == 0)
         { 
            if(SessionEndHour == 0)
            {
               if(TimeDayOfWeek(iTime(NULL,TF,0)) == 1 && TF == 1440) time2 = iTime(NULL,TF,0) + TF*60 + 3600*BaseHourShift;
               else
               time2 = (datetime)pivottime[shift] + TF*60;
            }
            else
            {
               if(TF >= 10080) time2 = tftime[shift] + TF*60 + SessionEndHour*3600; 
               else time2 = iTime(NULL,TF,shift) + SessionEndHour*3600; 
            
            }
         }
         else
         time2 = (datetime)pivottime[shift-1];
         
      if(ShowPivotValues) ratio0 = "("+DoubleToStr(ratios[0],3)+")"; else ratio0 = ""; 
      
      P  = pivotprice[shift];
      int istart = 0;
      
         if(DescriptionPlace == 0) desctime = time1 + 60*6*Period();
         else
         if(DescriptionPlace == 1) desctime = time1 + (time2 - time1)/2; 
         else
         if(DescriptionPlace == 2) desctime = time2 - 60*6*Period();
                  
         if(findInArray(ratios,0) >= 0)
         {
         PlotLine(UniqueName+" PP["+(string)shift+"]",P,MainPivotColor,MainPivotWidth,LineStyle);
                 
         PlotText(UniqueName+"value PP["+(string)shift+"]","PP "+DoubleToStr(P,digits)+" "+EnumToString(TimeFrame)+ratio0,desctime,P,FontSize,FontName,0,MainPivotColor); 
                  
         if(PivotMode == 3 || PivotMode == 4) istart = 1;
         }       
         
         for(i=istart;i<size;i++)
         {
         if(ShowGradientColor) coeff = (1 - (i+1.0)/size); else coeff = 0;  
         
            switch(PivotMode)
            {
            case 0:  if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P -                    low[shift] ,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P +   (high[shift] -   low[shift]),digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(2*P +   (high[shift] - 2*low[shift]),digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(  P + 2*(high[shift] -   low[shift]),digits);            
                     break;
            
            case 1:  if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/12.0,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/6.0 ,digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/4.0 ,digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(P + upRavg*1.1/2.0 ,digits);            
                     if(i == 4 && findInArray(ratios,5) >= 0) R[i] = NormalizeDouble((high[shift]/low[shift]*close[shift] + R[3])/2,digits);
                     if(i == 5 && findInArray(ratios,6) >= 0) R[i] = NormalizeDouble( high[shift]/low[shift]*close[shift],digits);
                     break;
                                 
            case 2:  if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P - low[shift],digits);    
                     break;
                     
            case 3:  if(ratios[i] > 0) R[i] = NormalizeDouble(P + ratios[i]*upRavg,digits);  
                     break;
            
            case 4:  if(ratios[i] > 0) R[i] = NormalizeDouble(P + ratios[i]*point,digits);  
                     break;
                     
            case 5:  if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(2*P  +                low[shift] ,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P  + (high[shift] - low[shift]),digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(R[1] + (high[shift] - low[shift]),digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(R[2] + (high[shift] - low[shift]),digits);            
                     break;            
            
            case 6:  
                     if(upRavg >= uprange[shift])
                     {
                     if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(  P  +  0.25*uprange[shift],digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P  +  0.50*uprange[shift],digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(  P  +  0.70*uprange[shift],digits); 
                     if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(R[0] + 1.272*(P - R[0])    ,digits);       
                     }
                     else
                     {
                     if(i == 0 && findInArray(ratios,1) >= 0) R[i] = NormalizeDouble(  P  +  0.12*uprange[shift],digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) R[i] = NormalizeDouble(  P  +  0.25*uprange[shift],digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) R[i] = NormalizeDouble(  P  +  0.33*uprange[shift],digits); 
                     if(i == 3 && findInArray(ratios,4) >= 0) R[i] = NormalizeDouble(R[0] + 1.272*(P - R[0])    ,digits);       
                     }
                     break;
            }
             
         upColor1 = (int)(upLineR + coeff*(ppLineR - upLineR));
         upColor2 = (int)(upLineG + coeff*(ppLineG - upLineG));
         upColor3 = (int)(upLineB + coeff*(ppLineB - upLineB));
         
         if(ShowPivotValues) ratioR = "("+DoubleToStr(ratios[i+1],3)+")"; else ratioR = "";
         
            if(R[i] > 0)
            {
            if((PivotMode == 3 || PivotMode == 4) && istart == 1) rnum = i; else rnum = i+1;
            PlotLine(UniqueName+" R"+(string)rnum+"["+(string)shift+"]",R[i],rgbToColor(upColor1,upColor2,upColor3),LineWidth,LineStyle);
         
               if(PivotMode == 1) rname = "H"+(string)rnum; 
               else
               if(PivotMode == 6)
               {
               if(i == 0) rname = "Buy";
               if(i == 1) rname = "BT1";
               if(i == 2) rname = "BT2";
               if(i == 3) rname = "BSL";
               } 
               else rname = "R"+(string)rnum; 
            
            PlotText(UniqueName+"value R"+(string)rnum+"["+(string)shift+"]",rname+" "+DoubleToStr(R[i],digits)+" "+EnumToString(TimeFrame)+ratioR,desctime,R[i],FontSize,FontName,0,rgbToColor(upColor1,upColor2,upColor3)); 
            }
            
            if(ShowMedians && R[i] > 0)
            {         
            if(i == istart) mr = (R[i] + P)/2; else mr = (R[i] + R[i-1])/2;
            PlotLine(UniqueName+" mR"+(string)num+"["+(string)shift+"]",mr,rgbToColor(upColor1,upColor2,upColor3),MedianWidth,MedianStyle);
            
            PlotText(UniqueName+"value mR"+(string)num+"["+(string)shift+"]","m"+rname+(string)num+"="+DoubleToStr(mr,digits)+" "+EnumToString(TimeFrame)+ratioR,desctime,mr,FontSize,FontName,0,rgbToColor(upColor1,upColor2,upColor3)); 
            }      
//----            
            switch(PivotMode)
            {
            case 0:  if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P -      high[shift]              ,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P -   (  high[shift] - low[shift]),digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(2*P -   (2*high[shift] - low[shift]),digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(  P - 2*(  high[shift] - low[shift]),digits);            
                     break;
            
            case 1:  if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/12.0,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/6.0 ,digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/4.0 ,digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(P - dnRavg*1.1/2.0 ,digits);            
                     if(i == 4 && findInArray(ratios,5) >= 0) S[i] = NormalizeDouble((2*close[shift] - high[shift]/low[shift]*close[shift] + S[3])/2,digits);
                     if(i == 5 && findInArray(ratios,6) >= 0) S[i] = NormalizeDouble( 2*close[shift] - R[5],digits);
                     break;
            
            case 2:  if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P - high[shift],digits);    
                     break;
            
            case 3:  if(ratios[i] > 0) S[i] = NormalizeDouble(P - ratios[i]*dnRavg,digits);
                     break;   
             
            case 4:  if(ratios[i] > 0) S[i] = NormalizeDouble(P - ratios[i]*point,digits);
                     break;
            
            case 5:  if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(2*P  -               high[shift] ,digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P  - (high[shift] - low[shift]),digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(S[1] - (high[shift] - low[shift]),digits);
                     if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(S[2] - (high[shift] - low[shift]),digits);            
                     break;
            
            case 6:  if(dnRavg >= dnrange[shift])
                     {
                     if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(  P  -  0.25*dnrange[shift],digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P  -  0.50*dnrange[shift],digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(  P  -  0.70*dnrange[shift],digits); 
                     if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(S[0] + 1.272*(P - S[0])    ,digits);       
                     }
                     else
                     {
                     if(i == 0 && findInArray(ratios,1) >= 0) S[i] = NormalizeDouble(  P  -  0.12*dnrange[shift],digits);       
                     if(i == 1 && findInArray(ratios,2) >= 0) S[i] = NormalizeDouble(  P  -  0.25*dnrange[shift],digits);   
                     if(i == 2 && findInArray(ratios,3) >= 0) S[i] = NormalizeDouble(  P  -  0.33*dnrange[shift],digits); 
                     if(i == 3 && findInArray(ratios,4) >= 0) S[i] = NormalizeDouble(S[0] + 1.272*(P - S[0])    ,digits);   
                     }
                     break;
            }
         
         dnColor1 = (int)(dnLineR + coeff*(ppLineR - dnLineR));
         dnColor2 = (int)(dnLineG + coeff*(ppLineG - dnLineG));
         dnColor3 = (int)(dnLineB + coeff*(ppLineB - dnLineB));
                  
         if(ShowPivotValues) ratioS = "(-"+DoubleToStr(ratios[i+1],3)+")"; else ratioS = ""; 
         
            if(S[i] > 0)
            {
            if((PivotMode == 3 || PivotMode == 4) && istart == 1) num = i; else num = i+1;
            PlotLine(UniqueName+" S"+(string)num+"["+(string)shift+"]",S[i],rgbToColor(dnColor1,dnColor2,dnColor3),LineWidth,LineStyle);
            
               if(PivotMode == 1) sname = "L" + (string)num; 
               else
               if(PivotMode == 6) 
               {
               if(i == 0) sname = "Sell"; 
               if(i == 1) sname = "ST1";
               if(i == 2) sname = "ST2";
               if(i == 3) sname = "SSL";
               }
               else sname = "S" + (string)num; 
            
            
            PlotText(UniqueName+"value S"+(string)num+"["+(string)shift+"]",sname+" "+DoubleToStr(S[i],digits)+" "+EnumToString(TimeFrame)+ratioS,desctime,S[i],FontSize,FontName,0,rgbToColor(dnColor1,dnColor2,dnColor3)); 
            }
            
            if(ShowMedians && S[i] > 0)
            {         
            if(i == istart) ms = (S[i] + P)/2; else ms = (S[i] + S[i-1])/2;
            PlotLine(UniqueName+" mS"+(string)num+"["+(string)shift+"]",ms,rgbToColor(dnColor1,dnColor2,dnColor3),MedianWidth,MedianStyle);
           
            PlotText(UniqueName+"value mS"+(string)num+"["+(string)shift+"]","m"+sname+(string)num+"="+DoubleToStr(ms,digits)+" "+EnumToString(TimeFrame)+ratioR,desctime,ms,FontSize,FontName,0,rgbToColor(dnColor1,dnColor2,dnColor3)); 
            }      
         }
   
         if(shift == 0 && ShowComment)
         Comment("\n\n","Average: upRange = ",upRavg/point," dnRange =",dnRavg/point);                                                       
       
        
      }
   
   fTime    = false;
   prevTime = curTime;
   pBars    = Bars;
   }      
        
   return(0);
}
//+------------------------------------------------------------------+

// ----
void PlotLine(string name,double value,color clr,int width,int style)
{
   bool res = ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY  , false);
   ObjectSet(name, OBJPROP_BACK , true);
   ObjectSet(name, OBJPROP_COLOR, clr);
}        

void PlotText(string name,string text,datetime time,double price,int _size,string font,bool back,color clr)
{
   ObjectCreate(name,OBJ_TEXT,0,time,price);
   ObjectSetText(name,text,_size,font,clr);
   ObjectSet(name,OBJPROP_BACK,back);
}

//+------------------------------------------------------------------+
int StrToDoubleArray(string str, double &a[], string delim=",", int init=0)  
//+------------------------------------------------------------------+
//  Breaks down a single string into double array 'a' (elements delimited by 'delim')
//  e.g. string is "1,2,3,4,5";  if delim is "," then the result will be
//  a[0]=1.0   a[1]=2.0   a[2]=3.0   a[3]=4.0   a[4]=5.0
//  Unused array elements are initialized by value in 'init' (default is 0)
{  
   int z1=-1, z2=0;
   
   if(str == "") return(0);  
   if(StringRight(str,1) != delim) str = str + delim;
   
   int strcnt = StringFindCount(str,delim);
   
   ArrayResize(a,strcnt);
   
   for(int i=0;i<strcnt;i++) a[i] = init;
   
   for(int i=0;i<strcnt;i++)  
   {
   z2 = StringFind(str,delim,z1+1);
   if(z2 > z1 + 1) a[i] = StrToNumber(StringSubstr(str,z1 + 1,z2 - z1 - 1));
   if(z2 >= StringLen(str) - 1) break;
   z1 = z2;
   }
  
   return(strcnt);
}

string StringRight(string str, int n=1)
//+------------------------------------------------------------------+
// Returns the rightmost N characters of STR, if N is positive
// Usage:    string x=StringRight("ABCDEFG",2)  returns x = "FG"
//
// Returns all but the leftmost N characters of STR, if N is negative
// Usage:    string x=StringRight("ABCDEFG",-2)  returns x = "CDEFG"
{
   if (n > 0)  return(StringSubstr(str,StringLen(str) - n,n));
   if (n < 0)  return(StringSubstr(str,-n,StringLen(str) - n));
  
   return("");
}

double StrToNumber(string str)  
//+------------------------------------------------------------------+
// Usage: strips all non-numeric characters out of a string, to return a numeric (double) value
// valid numeric characters are digits 0,1,2,3,4,5,6,7,8,9, decimal point (.) and minus sign (-)
// Example: StrToNumber("the balance is $-34,567.98") returns the numeric value -34567.98
{  
   int    dp    = -1;
   int    sgn   = 1;
   double snum  = 0.0;
  
   for (int i=0; i<StringLen(str); i++)  
   {
   string s = StringSubstr(str,i,1);
    if (s == "-")  sgn = -sgn;   else
    if (s == ".")  dp = 0;       else
      if (s >= "0" && s <= "9")  
      {
      if (dp >= 0)  dp++;
      if (dp > 0) snum = snum + StrToInteger(s)/MathPow(10,dp);
      else
      snum = snum*10 + StrToInteger(s);
      }
   }
   
   return(snum*sgn);
}

int StringFindCount(string str, string str2)
//+------------------------------------------------------------------+
// Returns the number of occurrences of STR2 in STR
// Usage:   int x = StringFindCount("ABCDEFGHIJKABACABB","AB")   returns x = 3
{
   int c = 0;
   for (int i=0; i<StringLen(str); i++)
      if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
   return(c);
}



bool ObjectDel(string name)
{
   int _GetLastError = 0;
     
   while(ObjFind(name,0,0) > 0)
   {
      int obtotal = ObjectsTotal();
      
      for (int i = 0; i < obtotal;i++)
      {
         if (StringFind(ObjectName(i),name,0) >= 0)
         {
            if (!ObjectDelete(ObjectName(i)))
            {
            _GetLastError = GetLastError();
            Print( "ObjectDelete( \"",ObjectName(i),"\" ) - Error #", _GetLastError );
            }
         }
      }
   }      
   return(true);
}


//-----
int ObjFind(string name,int start, int inum)
{
   int cnt = 0;
   
   for (int i = 0; i < ObjectsTotal();i++)
      if (StringFind(ObjectName(i),name,start) == inum) cnt+=1;
   
   return(cnt);
}

int rgbToColor(int clrR, int clrG, int clrB)
{
   return (256*(256*clrB + clrG) + clrR);
}

void colorToRGB(color clr,int& clrR, int& clrG, int& clrB)
{
   clrR = clr&0x000000FF;
   clrG = (clr>>8)&0x000000FF;
   clrB = (clr>>16)&0x000000FF; 
}

double basePrice(int mode,double prevo,double o,double h, double l,double c)
{

   switch(mode)
   {
   case 0:  return(c); 
   case 1:  return(o);
   case 2:  return(h);
   case 3:  return(l);
   case 4:  return((h+l)/2);
   case 5:  return((h+l+c)/3);
   case 6:  return((h+l+2*c)/4);
   case 7:  return((h+l+2*o)/4);
   }
   
   return(0);
}

double findInArray(double& array[],double value)
{
   for(int i=0;i<ArraySize(array);i++) 
      if(array[i] == value) return(i); 

   return(-1);
}

int countDigits(double ipoint)
{
   int count = 0;
   
   while(ipoint*MathPow(10,count) != MathRound(ipoint*MathPow(10,count))) count += 1;
   
   return(count);
}
    